{% macro render_time_field(field, label_visible=true) -%}

    <div class="form-group {% if field.errors %}has-error{% endif %} {{ kwargs.pop('class_', '') }}">
        {% if label_visible %}
            {{ field.label(class_="control-label") }}
        {% endif %}
        <input class="form-control" id="{{ field.id }}" name="{{ field.name }}" type="text" value="" pattern="(\d\d[:h])?[0-5]?\d[:m][0-5]?\ds?" title="HH:MM:SS or MM:SS">
        {% if field.errors %}
            {% for e in field.errors %}
                <div class="invalid-feedback">{{ e }}</div>
            {% endfor %}
        {% endif %}
        {% if field.description %}
            <small id="passwordHelpBlock" class="form-text text-muted">{{ field.description }}</small>
        {% endif %}
    </div>
{%- endmacro %}


{# Renders field for bootstrap 4 standards.

    Params:
        field - WTForm field
        kwargs - pass any arguments you want in order to put them into the html attributes.
        There are few exceptions: for - for_, class - class_, class__ - class_

    Example usage:
        {{ macros.render_field(form.email, placeholder='Input email', type='email') }}
#}
{% macro render_field(field, label_visible=true) -%}

    <div class="form-group {% if field.errors %}has-error{% endif %} {{ kwargs.pop('class_', '') }}">
        {% if field.type != 'HiddenField' and field.type !='CSRFTokenField' and label_visible %}
            {{ field.label(class_="control-label") }}
        {% endif %}
        {{ field(class_='form-control ' + ('is-invalid' if field.errors else ''), **kwargs) }}
        {% if field.errors %}
            {% for e in field.errors %}
                <div class="invalid-feedback">{{ e }}</div>
            {% endfor %}
        {% endif %}
        {% if field.description %}
            <small id="passwordHelpBlock" class="form-text text-muted">{{ field.description }}</small>
        {% endif %}
    </div>
{%- endmacro %}

{# Renders checkbox fields since they are represented differently in bootstrap
    Params:
        field - WTForm field (there are no check, but you should put here only BooleanField.
        kwargs - pass any arguments you want in order to put them into the html attributes.
        There are few exceptions: for - for_, class - class_, class__ - class_

    Example usage:
        {{ macros.render_checkbox_field(form.remember_me) }}
 #}
{% macro render_checkbox_field(field) -%}
    <div class="checkbox {{ 'hidden' if field.id == 'r_accept' }}">
        <label>
            {{ field(type='checkbox', **kwargs) }} {{ field.label.text }}
        </label>
    </div>
{%- endmacro %}

{# Renders radio field
    Params:
        field - WTForm field (there are no check, but you should put here only BooleanField.
        kwargs - pass any arguments you want in order to put them into the html attributes.
        There are few exceptions: for - for_, class - class_, class__ - class_

    Example usage:
        {{ macros.render_radio_field(form.answers) }}
 #}
{% macro render_radio_field(field) -%}
    {% for value, label, _ in field.iter_choices() %}
        <div class="radio">
            <label>
                <input type="radio" name="{{ field.id }}" id="{{ field.id }}" value="{{ value }}">{{ label }}
            </label>
            {% if field.errors %}
            {% for e in field.errors %}
                <div class="invalid-feedback">{{ e }}</div>
            {% endfor %}
        {% endif %}
        </div>
    {% endfor %}
{%- endmacro %}


{# Renders WTForm in bootstrap way. There are two ways to call function:
     - as macros: it will render all field forms using cycle to iterate over them
     - as call: it will insert form fields as you specify:
     e.g. {% call macros.render_form(form, action_url=url_for('login_view'), action_text='Login',
                                        class_='login-form') %}
                {{ macros.render_field(form.email, placeholder='Input email', type='email') }}
                {{ macros.render_field(form.password, placeholder='Input password', type='password') }}
                {{ macros.render_checkbox_field(form.remember_me, type='checkbox') }}
            {% endcall %}

     Params:
        form - WTForm class
        action_url - url where to submit this form
        action_text - text of submit button
        class_ - sets a class for form
    #}
{% macro render_form(form, action_url='', action_text='Submit', class_='',
                     btn_class='btn btn-default',
                     cancel_url='', cancel_text='Cancel',
                     cancel_class='col-xs-offset-1')
-%}

    <form method="POST" {% if action_url %} action="{{ action_url }}" {%endif %} role="form" class="{{ class_ }}">
        {{ form.hidden_tag() if form.hidden_tag }}
        {% if caller %}
            {{ caller() }}
        {% else %}
            {% for f in form %}
                {% if f.type == 'BooleanField' %}
                    {{ render_checkbox_field(f) }}
                {% elif f.type == 'RadioField' %}
                    {{ render_radio_field(f) }}
                {% elif f.type == 'CSRFTokenField' %}
{#                 {% elif f.type == 'TimeField' %}
                    {{ render_time_field(f) }} #}
                {% elif f.type == 'SubmitField' %}
                    <button type="submit" class="{{ btn_class }}">{{ f.label.text }}</button>
                {% else %}
                    {{ render_field(f) }}
                {% endif %}
            {% endfor %}
        {% endif %}
        {% if cancel_url %}
            <a href="{{ cancel_url }}" class="{{ cancel_class }}">
                {{- cancel_text }}</a>
        {% endif %}
    </form>
{%- endmacro %}